import pathlib

import dunamai
import tomlkit


def main():
    result = dunamai.Version.from_git(
        strict=True, pattern=dunamai.Pattern.DefaultUnprefixed, pattern_prefix=r"v[^/]+/"
    )
    # Example: "v14/1.12.0"
    tag = result._matched_tag
    track, _ = tag.split("/")
    # Example: "14"
    track = track[1:]
    # Example: "14/1.12.0.post1.dev0+71201f4.dirty"
    charm_version = f"{track}/{result.serialize(dirty=True)}"

    path = pathlib.Path("refresh_versions.toml")
    with path.open("r") as file:
        versions = tomlkit.load(file)
    versions["charm"] = charm_version
    versions["charm"].comment("Autogenerated at build time")
    with path.open("w") as file:
        tomlkit.dump(versions, file)
